0*0. --------------------------------------------------------------------
* This is the Input-output model (IOM) series
* ǹͶģ͵ļ㣬аģͺ͹ʲģ
*---------------------------------------------------------------------
$OFFLISTING
OPTION LIMROW=0, LIMCOL=0
Option decimals = 5
;

SET
RIOT Row of IO Table /
01 Primary industry              һҵ
02 Secondary industry            ڶҵ
03 Tertiary industry             ҵ
04 Intermediate input or output  мͶмʹúϼ
05 Prmary factor input           ʼҪͶʹ֧
06 Value added                   ʼͶ루ֵʹúϼ
07 Total input or output         Ͷܲ
/
;
ALIAS(RIOT,CIOT)

SETS
 PS(RIOT)         Production sectors /01*03/
 FI(RIOT)         Factor Input or Value added /05/
 FU(CIOT)         Final Use or demands /05/
;
ALIAS(PS,PS1,PS0)
*----------------------------------
*The Model Variables and Parameters
*----------------------------------
PARAMETERS
IOT30(RIOT,CIOT)       Original IOT data                            ԭʼͶ
IOT3(*,*)              Free table to hold data                      ݵɱ
IOT3_LT(*,*)           Free table to hold data of Leontief model    аģݵɱ
IOT3_GH(*,*)           Free table to hold data of Ghosh model       Źʲģݵɱ

xx(PS,PS1)             Intermediate Input matrix                    мĻʹþ
II(PS1)                Sum of intermediate inputs                   мľк
VI(FI,PS1)             Factor Input or income matrix                ҪͶ
V(PS1)                 Sum of factor input or income                ҪͶϼ
TI(PS)                 Total Input or Domestic produciton           Ͷ
IO(PS)                 Intermediate Outputs                         мʹþк
FD(PS,FU)              Final Demands or expenditure matrix          ʹþ
Y(PS)                  Sum of final demands or Final Expenditure    ʹû֧ϼ
TO(PS)                 Total Outputs                                ܲ

I(PS,PS1)              Diagnol matrix                               λ

ac(PS,PS1)             Coefficients of intermediate inputs or uses  мϵ
fic(FI,PS1)            Coefficients of factor inputs                ҪͶϵ
fds(PS,FU)             Composition or share of final demands        ʹϵ
A(PS,PS1)              Matrix of ac coefficients                    амϵ
A1(PS,PS1)             Matrix of I-A                                аϵ
INVA(PS,PS1)           Inverse of matrix I-A                        амϵ

bc(PS,PS1)             Coefficients of intermediate distibution     мϵ
fis(FI,PS)             omposition or Share of Factor distribution   Ҫطϵ
fdc(PS,FU)             Coefficients of final distribution           շϵ
B(PS,PS1)              Matrix of b coefficients                     ʲмϵ
B1(PS,PS1)             Matrix of I-B                                ʲշϵ
INVB(PS,PS1)           Inverse of matrix I-B                        ʲмϵ

X(PS)                  Total input or output                        Ͷܲ

Y_LT(PS)               for LeonTief model
X_LT(PS)               for LeonTief model
V_LT(PS)               for LeonTief model
xx_LT(PS,PS1)          for LeonTief model
II_LT(PS)              for LeonTief model
VI_LT(FI,PS1)          for LeonTief model
TI_LT(PS)              for LeonTief model
IO_LT(PS)              for LeonTief model
FD_LT(PS,FU)           for LeonTief model
TO_LT(PS)              for LeonTief model

Y_GH(PS)               for GHosh model
X_GH(PS)               for GHosh model
V_GH(PS)               for GHosh model
xx_GH(PS,PS1)          for GHosh model
II_GH(PS)              for GHosh model
VI_GH(FI,PS1)          for GHosh model
TI_GH(PS)              for GHosh model
IO_GH(PS)              for GHosh model
FD_GH(PS,FU)           for GHosh model
TO_GH(PS)              for GHosh model
;
*---------------------
*The Data Files
*---------------------
$libinclude xlimport IOT30 IOT2007.xlsx IOT30!D5:K12
IOT30(RIOT,CIOT) = IOT30(RIOT,CIOT)/10000;

*------------------------------------------
* Input-output data
*------------------------------------------
xx(PS,PS1) = IOT30(PS,PS1);
II(PS1) = SUM(PS,IOT30(PS,PS1));
VI(FI,PS1) = IOT30(FI,PS1);
V(PS1) = SUM(FI,VI(FI,PS1));
*TI(PS1) = IOT30("07",PS1);
TI(PS1) = II(PS1)+V(PS1);
IO(PS) = SUM(PS1,IOT30(PS,PS1));
FD(PS,FU) = IOT30(PS,FU);
Y(PS) = SUM(FU,FD(PS,FU));
*TO(PS) = IOT30(PS,"07");
TO(PS) = IO(PS)+Y(PS);
X(PS)  = TO(PS);

*calculate input-output coefficients
I(PS,PS1) = 0$(ORD(PS)<>ORD(PS1))+1$(ORD(PS)=ORD(PS1));

ac(PS,PS1) = xx(PS,PS1)/X(PS1);
fic(FI,PS1) = VI(FI,PS1)/X(PS1);
fds(PS,FU) = FD(PS,FU)/SUM(PS0,FD(PS0,FU));

bc(PS,PS1) = xx(PS,PS1)/X(PS);
fdc(PS,FU) = FD(PS,FU)/X(PS);
fis(FI,PS) = VI(FI,PS)/SUM(PS0,VI(FI,PS0));

*compute inverse matrix
A(PS,PS1) = ac(PS,PS1);
A1(PS,PS1) = I(PS,PS1)-A(PS,PS1);
execute_unload 'gdxforinverse.gdx' PS,A1;
execute 'invert gdxforinverse.gdx PS A1 gdxfrominverse.gdx INVA';
execute_load 'gdxfrominverse.gdx', INVA;

B(PS,PS1) = bc(PS,PS1);
*B(PS,PS1) = B(PS1,PS);
B1(PS,PS1) = I(PS,PS1)-B(PS,PS1);
execute_unload 'gdxforinverse.gdx' PS,B1;
execute 'invert gdxforinverse.gdx PS B1 gdxfrominverse.gdx INVB';
execute_load 'gdxfrominverse.gdx', INVB;

* ------------- Leontief model -------------------------
*Basic case
Y_LT(PS)  = Y(PS);
*ScenaRIOT1: Y increases by 1% to see ?% increse of V
Y_LT(PS) = (1+0.01)*Y(PS);
X_LT(PS)  = SUM(PS1,INVA(PS,PS1)*Y_LT(PS1));
V_LT(PS) = SUM(FI,fic(FI,PS)*X_LT(PS));
xx_LT(PS,PS1) = ac(PS,PS1)*X_LT(PS1);
II_LT(PS1)     = SUM(PS,xx_LT(PS,PS1));
VI_LT(FI,PS1) = fic(FI,PS1)*X_LT(PS1);
TI_LT(PS)     = X_LT(PS);
IO_LT(PS)     = SUM(PS1,xx_LT(PS,PS1));
FD_LT(PS,FU)  = fds(PS,FU)*SUM(PS0,Y_LT(PS0));
TO_LT(PS)     = TI_LT(PS);

* ------------- Ghosh model ----------------------------
*Basic case
V_GH(PS) = V(PS);
*ScenaRIOT1: V increases by 5% to see ?% increse of Y
V_GH(PS) = (1+0.05)*V(PS);
X_GH(PS1) = SUM(PS,INVB(PS,PS1)*V_GH(PS));
Y_GH(PS) = SUM(FU,fdc(PS,FU)*X_GH(PS));
xx_GH(PS,PS1) = bc(PS,PS1)*X_GH(PS);
II_GH(PS1)     = SUM(PS,xx_GH(PS,PS1));
VI_GH(FI,PS) = fis(FI,PS)*SUM(PS0,V_GH(PS0));
TI_GH(PS)     = X_GH(PS);
IO_GH(PS)     = SUM(PS1,xx_GH(PS,PS1));
FD_GH(PS,FU)  = fdc(PS,FU)*X_GH(PS);
TO_GH(PS)     = TI_GH(PS);

display X,X_LT,X_GH;
*-----------------------------------
* Print Original Input-output Tables
*-----------------------------------
FILE IOT_31 /IOT31.CSV/;
put IOT_31;IOT_31.PC=5;IOT_31.ND=6;IOT_31.NZ=1.0E-13;IOT_31.NW=20;IOT_31.PW=32767

PUT 'xx(PS,PS1)';
LOOP(PS1, PUT PS1.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(PS1,PUT xx(PS,PS1));PUT/;);
PUT/;
PUT/;
PUT 'PS1';
LOOP(PS1,PUT PS1.TL;);PUT/;
PUT 'II(PS)';LOOP(PS,PUT II(PS););PUT/;
PUT/;
PUT 'VI(FI,PS1)';
LOOP(PS1, PUT PS1.TL;);PUT/;
LOOP(FI,PUT FI.TL;LOOP(PS1,PUT VI(FI,PS1));PUT/;);
PUT/;
PUT 'PS1';
LOOP(PS1,PUT PS1.TL;);PUT/;
PUT 'V(PS)';LOOP(PS,PUT V(PS););PUT/;
PUT/;
PUT 'PS1';
LOOP(PS1,PUT PS1.TL;);PUT/;
PUT 'TI(PS)';LOOP(PS,PUT TI(PS););PUT/;
PUT/;
PUT 'PS';PUT 'IO(PS)'/;
LOOP(PS,PUT PS.TL;PUT IO(PS);PUT/;);
PUT/;
PUT 'PS';PUT 'FD(PS,FU)'/;
PUT '  ';LOOP(FU, PUT FU.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(FU,PUT FD(PS,FU));PUT/;);
PUT/;
PUT 'PS';PUT 'Y(PS)'/;
LOOP(PS,PUT PS.TL;PUT Y(PS);PUT/;);
PUT/;
PUT 'PS';PUT 'TO(PS)'/;
LOOP(PS,PUT PS.TL;PUT TO(PS);PUT/;);

* Creat a 3 sectors simple IO Table -----------------------------
IOT3(RIOT,CIOT) =
                   SUM(PS$(ORD(PS)=ORD(RIOT)),SUM(PS1$(ORD(PS1)=ORD(CIOT)),xx(PS,PS1)))
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),IO(PS))$(ORD(CIOT)=4)
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),SUM(FU$(ORD(CIOT)=ORD(FU)+4),FD(PS,FU)))
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),Y(PS))$(ORD(CIOT)=6)
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),TO(PS))$(ORD(CIOT)=7)
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),II(PS1))$(ORD(RIOT)=4)
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),SUM(FI$(ORD(RIOT)=ORD(FI)+4),VI(FI,PS1)))
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),V(PS1))$(ORD(RIOT)=6)
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),TI(PS1))$(ORD(RIOT)=7)
;
$LIBINCLUDE XLDUMP IOT3 IOT2007.XLSX IOT32!B2

Execute_Unload 'IOT_3.gdx',IOT3;
Execute "GDXXRW I=IOT_3.gdx O=IOT2007.xlsx par=IOT3 Rng=IOT33!D5 Rdim=1 Cdim=1";

*------------------------------------------
* Print the Results of Leontief Model
*------------------------------------------
FILE IOM_LT /IOM_LT.CSV/;
put IOM_LT;
IOM_LT.PC=5;IOM_LT.ND=6;IOM_LT.NZ=1.E-6;IOM_LT.NW=20;IOM_LT.PW=450

*replicate the Input-output table
PUT 'xx_LT(PS,PS1)';
LOOP(PS1, PUT PS1.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(PS1,PUT xx_LT(PS,PS1));PUT/;);
PUT/;
PUT/;
PUT 'PS1';
LOOP(PS1,PUT PS1.TL;);PUT/;
PUT 'II_LT(PS)';LOOP(PS,PUT II_LT(PS););PUT/;
PUT/;
PUT 'VI_LT(FI,PS1)';
LOOP(PS1, PUT PS1.TL;);PUT/;
LOOP(FI,PUT FI.TL;LOOP(PS1,PUT VI_LT(FI,PS1));PUT/;);
PUT/;
PUT 'PS1';
LOOP(PS1,PUT PS1.TL;);PUT/;
PUT 'V_LT(PS)';LOOP(PS,PUT V_LT(PS););PUT/;
PUT/;
PUT 'PS1';
LOOP(PS1,PUT PS1.TL;);PUT/;
PUT 'TI_LT(PS)';LOOP(PS,PUT TI_LT(PS););PUT/;
PUT/;
PUT 'PS';PUT 'IO_LT(PS)'/;
LOOP(PS,PUT PS.TL;PUT IO_LT(PS);PUT/;);
PUT/;
PUT 'PS';PUT 'FD_LT(PS,FU)'/;
PUT '  ';LOOP(FU, PUT FU.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(FU,PUT FD_LT(PS,FU));PUT/;);
PUT/;
PUT 'PS';PUT 'Y_LT(PS)'/;
LOOP(PS,PUT PS.TL;PUT Y_LT(PS);PUT/;);
PUT/;
PUT 'PS';PUT 'TO_LT(PS)'/;
LOOP(PS,PUT PS.TL;PUT TO_LT(PS);PUT/;);

PUT 'V_LT(PS)'/;
LOOP(PS,PUT PS.TL;PUT V_LT(PS);PUT/;);
PUT 'Y_LT(PS)'/;
LOOP(PS,PUT PS.TL;PUT Y_LT(PS);PUT/;);
PUT 'X_LT(PS)'/;
LOOP(PS,PUT PS.TL;PUT X_LT(PS);PUT/;);

PUT 'IOT30';LOOP(CIOT,PUT CIOT.TL;);PUT/;
LOOP(RIOT,PUT RIOT.TL;LOOP(CIOT,PUT IOT30(RIOT,CIOT));PUT/;);PUT/;

PUT 'I matrix';LOOP(PS1,PUT PS1.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(PS1,PUT I(PS,PS1));PUT/;);PUT/;
PUT 'A matrix';LOOP(PS1,PUT PS1.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(PS1,PUT A(PS,PS1));PUT/;);PUT/;
PUT 'A1 matrix';LOOP(PS1,PUT PS1.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(PS1,PUT A1(PS,PS1));PUT/;);PUT/;
PUT 'Leontief inverse';LOOP(PS1,PUT PS1.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(PS1,PUT INVA(PS,PS1));PUT/;);PUT/;

* Creat a 3 sectors simple IO Table -----------------------------
IOT3_LT(RIOT,CIOT) =
                   SUM(PS$(ORD(PS)=ORD(RIOT)),SUM(PS1$(ORD(PS1)=ORD(CIOT)),xx_LT(PS,PS1)))
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),IO_LT(PS))$(ORD(CIOT)=4)
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),SUM(FU$(ORD(CIOT)=ORD(FU)+4),FD_LT(PS,FU)))
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),Y_LT(PS))$(ORD(CIOT)=6)
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),TO_LT(PS))$(ORD(CIOT)=7)
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),II_LT(PS1))$(ORD(RIOT)=4)
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),SUM(FI$(ORD(RIOT)=ORD(FI)+4),VI_LT(FI,PS1)))
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),V_LT(PS1))$(ORD(RIOT)=6)
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),TI_LT(PS1))$(ORD(RIOT)=7)
;
$LIBINCLUDE XLDUMP IOT3_LT IOT2007.XLSX IOT32_LT!B2

Execute_Unload 'IOT_3_LT.gdx',IOT3_LT;
Execute "GDXXRW I=IOT_3_LT.gdx O=IOT2007.xlsx par=IOT3_LT Rng=IOT33_LT!D5:L13 Rdim=1 Cdim=1";
*------------------------------------------
* Print the Results of Ghosh Model
*------------------------------------------
FILE IOM_GH /IOM_GH.CSV/;
put IOM_GH;
IOM_GH.PC=5;IOM_GH.ND=6;IOM_GH.NZ=1.E-6;IOM_GH.NW=20;IOM_GH.PW=450

*replicate the Input-output table
PUT 'xx_GH(PS,PS1)';
LOOP(PS1, PUT PS1.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(PS1,PUT xx_GH(PS,PS1));PUT/;);
PUT/;
PUT/;
PUT 'PS1';
LOOP(PS1,PUT PS1.TL;);PUT/;
PUT 'II_GH(PS)';LOOP(PS,PUT II_GH(PS););PUT/;
PUT/;
PUT 'VI_GH(FI,PS1)';
LOOP(PS1, PUT PS1.TL;);PUT/;
LOOP(FI,PUT FI.TL;LOOP(PS1,PUT VI_GH(FI,PS1));PUT/;);
PUT/;
PUT 'PS1';
LOOP(PS1,PUT PS1.TL;);PUT/;
PUT 'V_GH(PS)';LOOP(PS,PUT V_GH(PS););PUT/;
PUT/;
PUT 'PS1';
LOOP(PS1,PUT PS1.TL;);PUT/;
PUT 'TI_GH(PS)';LOOP(PS,PUT TI_GH(PS););PUT/;
PUT/;
PUT 'PS';PUT 'IO_GH(PS)'/;
LOOP(PS,PUT PS.TL;PUT IO_GH(PS);PUT/;);
PUT/;
PUT 'PS';PUT 'FD_GH(PS,FU)'/;
PUT '  ';LOOP(FU, PUT FU.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(FU,PUT FD_GH(PS,FU));PUT/;);
PUT/;
PUT 'PS';PUT 'Y_GH(PS)'/;
LOOP(PS,PUT PS.TL;PUT Y_GH(PS);PUT/;);
PUT/;
PUT 'PS';PUT 'TO_GH(PS)'/;
LOOP(PS,PUT PS.TL;PUT TO_GH(PS);PUT/;);

PUT 'V_GH(PS)'/;
LOOP(PS,PUT PS.TL;PUT V_GH(PS);PUT/;);
PUT 'Y_GH(PS)'/;
LOOP(PS,PUT PS.TL;PUT Y_GH(PS);PUT/;);
PUT 'X_GH(PS)'/;
LOOP(PS,PUT PS.TL;PUT X_GH(PS);PUT/;);

PUT 'IOT30';LOOP(CIOT,PUT CIOT.TL;);PUT/;
LOOP(RIOT,PUT RIOT.TL;LOOP(CIOT,PUT IOT30(RIOT,CIOT));PUT/;);PUT/;

PUT 'I matrix';LOOP(PS1,PUT PS1.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(PS1,PUT I(PS,PS1));PUT/;);PUT/;

PUT 'B matrix';LOOP(PS1,PUT PS1.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(PS1,PUT B(PS,PS1));PUT/;);PUT/;
PUT 'B1 matrix';LOOP(PS1,PUT PS1.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(PS1,PUT B1(PS,PS1));PUT/;);PUT/;
PUT 'Ghosh inverse';LOOP(PS1,PUT PS1.TL;);PUT/;
LOOP(PS,PUT PS.TL;LOOP(PS1,PUT INVB(PS,PS1));PUT/;);PUT/;

* Creat a 3 sectors simple IO Table -----------------------------
IOT3_GH(RIOT,CIOT) =
                   SUM(PS$(ORD(PS)=ORD(RIOT)),SUM(PS1$(ORD(PS1)=ORD(CIOT)),xx_GH(PS,PS1)))
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),IO_GH(PS))$(ORD(CIOT)=4)
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),SUM(FU$(ORD(CIOT)=ORD(FU)+4),FD_GH(PS,FU)))
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),Y_GH(PS))$(ORD(CIOT)=6)
                  +SUM(PS$(ORD(PS)=ORD(RIOT)),TO_GH(PS))$(ORD(CIOT)=7)
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),II_GH(PS1))$(ORD(RIOT)=4)
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),SUM(FI$(ORD(RIOT)=ORD(FI)+4),VI_GH(FI,PS1)))
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),V_GH(PS1))$(ORD(RIOT)=6)
                  +SUM(PS1$(ORD(PS1)=ORD(CIOT)),TI_GH(PS1))$(ORD(RIOT)=7)
;
$LIBINCLUDE XLDUMP IOT3_GH IOT2007.XLSX IOT32_GH!B2

Execute_Unload 'IOT_3_GH.gdx',IOT3_GH;
Execute "GDXXRW I=IOT_3_GH.gdx O=IOT2007.xlsx par=IOT3_GH Rng=IOT33_GH!D5:L13 Rdim=1 Cdim=1";
